<template>
  <div class="map rounded-md overflow-hidden relative">
    <template v-if="!selected_meter.id">
      <div
        class="absolute top-4 left-4 z-10 px-3 py-2 bg-white rounded-md shadow w-3/4 flex items-center"
      >
        <img
          :src="require('~/assets/images/magnifying-glass (2) 1.svg')"
          alt="magnifying-glass (2) 1.svg"
        />

        <input
          v-model="search"
          type="text"
          placeholder="Search..."
          class="p-0 w-full text-black focus:outline-none ml-3"
          @input="searchMap"
        />
      </div>

      <div
        class="type absolute inset-x-0 mx-auto bottom-4 z-10 font-semibold flex justify-center pointer-events-none"
      >
        <div class="px-5 py-2 rounded-l-3xl bg-primary">อุปกรณ์ปกติ</div>

        <div class="px-5 py-2 rounded-r-3xl bg-orange">ออฟไลน์</div>
      </div>
    </template>

    <div id="map" class="h-full"></div>
  </div>
</template>

<script>
import _ from "lodash";
import { Loader } from "@googlemaps/js-api-loader";

export default {
  props: {
    map_data: {
      type: Array,
      default: () => {
        return [];
      },
    },
    selected_meter: {
      type: Object,
      default: () => {
        return {};
      },
    },
    selectMeter: {
      type: Function,
      default: () => {
        return {};
      },
    },
  },
  data() {
    return {
      map: null,
      markers: [],
      center: {
        lat: 13.736717,
        lng: 100.523186,
      },
      search: "",
    };
  },
  watch: {
    "selected_meter.id"(newValue, oldValue) {
      this.selectMarker();
    },
  },
  mounted() {
    this.setMap();
  },
  methods: {
    setMap() {
      const loader = new Loader({
        apiKey: process.env.g_map_api_key,
        version: "weekly",
      });

      loader.load().then(() => {
        this.map = new google.maps.Map(document.getElementById("map"), {
          center: this.center,
          zoom: 18,
          fullscreenControl: false,
          mapTypeControl: false,
          streetViewControl: false,
          mapTypeId: "satellite",
        });

        this.setMarker();
        this.searchMap();
      });
    },
    setMarker() {
      _.forEach(this.map_data, (d) => {
        const marker = new google.maps.Marker({
          raw_data: d,
          position: new google.maps.LatLng(d.position.lat, d.position.lng),
          icon:
            d.status === "offline"
              ? require("~/assets/images/pin_orange.svg")
              : require("~/assets/images/pin_blue.svg"),
          map: this.map,
        });

        this.markers.push(marker);

        marker.addListener("click", ({ domEvent, latLng }) => {
          this.selectMeter(marker.raw_data);
        });
      });
    },
    selectMarker() {
      _.forEach(this.markers, (m) => {
        if (m.raw_data.id === this.selected_meter.id) {
          m.setIcon(require("~/assets/images/energy 1.svg"));
          this.map.setCenter(
            new google.maps.LatLng(
              m.raw_data.position.lat,
              m.raw_data.position.lng
            )
          );
        } else {
          m.setIcon(
            m.raw_data.status === "offline"
              ? require("~/assets/images/pin_orange.svg")
              : require("~/assets/images/pin_blue.svg")
          );
        }
      });
    },
    searchMap: _.debounce(function () {
      const filter_markers = _.filter(this.markers, (m) =>
        m.raw_data.name.includes(this.search)
      );

      const markers = filter_markers.length > 0 ? filter_markers : this.markers;

      if (markers.length > 0) {
        const bounds = new google.maps.LatLngBounds();

        _.forEach(markers, (m) => {
          if (m.getVisible()) bounds.extend(m.getPosition());
        });

        this.map.fitBounds(bounds);
      }
    }, 200),
  },
};
</script>

<style lang="scss" scoped></style>
